#include "stdafx.h"
#include "JSAPrivate.hpp"

namespace JSA
{
    CHashList::CHashList() : m_pFirstHash(0),m_pLastHash(0),m_nNodeCount(0)
    {

    }

    CHashList::~CHashList()
    {
    }

    void CHashList::Add(HashNode * pNode,unsigned long long nChainLimit)
    {
        if (m_nNodeCount == nChainLimit)
        {
            Remove(m_pFirstHash);
        }

        m_pLastHash->NextNode = pNode;
        pNode->PrevNode = m_pLastHash;
        m_pLastHash = pNode;

        ++m_nNodeCount;
    }

    void CHashList::Remove(HashNode * pNode)
    {
        if (pNode->PrevNode != 0)
        {
            pNode->PrevNode->NextNode = pNode->NextNode;
        }
        else
        {
            m_pFirstHash = pNode->NextNode;
        }

        if (pNode->NextNode != 0)
        {
            pNode->NextNode->PrevNode = pNode->NextNode;
        }
        else
        {
            m_pLastHash = pNode->PrevNode;
        }

        --m_nNodeCount;

        pNode->OwnerList = 0;
        pNode->Position = 0;
        pNode->DataPtr = 0;
        pNode->PrevNode = 0;
        pNode->NextNode = 0;
    }
}
